pub mod pb {
    tonic::include_proto!("bky.registry.api");
}

use pb::{
    metadata_ops_client::MetadataOpsClient, PullCreateReq, PullCreateResp, PushCreateReq,
    PushCreateResp, QueryDirdentsReq, QueryDirdentsResp, RemoveReq, RemoveResp, UpdateReq,
    UpdateResp, WatchUpdateReq, WatchUpdateResp,
};
use tonic::transport::Channel;

async fn create_by_pull(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}
async fn create_by_push(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}
async fn remove(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}
async fn update(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}
async fn query_dirdents(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}

async fn watch_update(client: &mut MetadataOpsClient<Channel>) {
    let req = PullCreateReq {
        send_type: 1,
        tcode: 1.to_string(),
    };
    let resp = client.create_by_pull(req).await.unwrap().into_inner();
    println!("resp={:?}", resp);
}

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let mut client = MetadataOpsClient::connect("http://[::1]:50051")
        .await
        .unwrap();
    create_by_pull(&mut client).await;
    create_by_push(&mut client).await;
    remove(&mut client).await;
    update(&mut client).await;
    query_dirdents(&mut client).await;
    watch_update(&mut client).await;
    println!("fdfd");
    Ok(())
}
