pub mod pb {
    tonic::include_proto!("bky.registry.api");
}
use std::{error::Error, io::ErrorKind, net::ToSocketAddrs, pin::Pin, time::Duration};

use futures::Stream;
use pb::{
    Metadata, PullCreateReq, PullCreateResp, PushCreateReq, PushCreateResp, QueryDirdentsReq,
    QueryDirdentsResp, RemoveReq, RemoveResp, UpdateReq, UpdateResp, WatchUpdateReq,
    WatchUpdateResp,
};
use tonic::{transport::Server, Request, Response, Status, Streaming};
#[derive(Debug)]
pub struct MetadataOpsServer {}

type MetadataResult<T> = Result<Response<T>, Status>;
type ResponseStream = Pin<Box<dyn Stream<Item = Result<WatchUpdateResp, Status>> + Send>>;

#[tonic::async_trait]
impl pb::metadata_ops_server::MetadataOps for MetadataOpsServer {
    async fn create_by_pull(&self, _: Request<PullCreateReq>) -> MetadataResult<PullCreateResp> {
        // Err(Status::unimplemented("..."))
        let md: Metadata = Metadata {
            kv: "hello".to_string(),
        };
        let mut mdv = vec![];
        mdv.push(md);
        let reply = PullCreateResp {
            ret_code: 1,
            tcode: 1.to_string(),
            md: mdv,
        };
        Ok(Response::new(reply))
    }

    async fn create_by_push(&self, _: Request<PushCreateReq>) -> MetadataResult<PushCreateResp> {
        Err(Status::unimplemented("..."))
    }

    async fn remove(&self, _: Request<RemoveReq>) -> MetadataResult<RemoveResp> {
        Err(Status::unimplemented("..."))
    }

    async fn update(&self, _: Request<UpdateReq>) -> MetadataResult<UpdateResp> {
        Err(Status::unimplemented("..."))
    }

    async fn query_dirdents(
        &self,
        _: Request<QueryDirdentsReq>,
    ) -> MetadataResult<QueryDirdentsResp> {
        Err(Status::unimplemented("..."))
    }
    type WatchUpdateStream = ResponseStream;
    async fn watch_update(
        &self,
        _: Request<WatchUpdateReq>,
    ) -> MetadataResult<Self::WatchUpdateStream> {
        Err(Status::unimplemented("..."))
    }
}

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let server = MetadataOpsServer {};
    Server::builder()
        .add_service(pb::metadata_ops_server::MetadataOpsServer::new(server))
        .serve("[::1]:50051".to_socket_addrs().unwrap().next().unwrap())
        .await
        .unwrap();
    println!("fdfd");
    Ok(())
}
